/* EPFL */

#include <stdio.h>

#define FNAME "magic.in"
#define MAXN 10

int main()
{
	int i,j,elt;
	int N = 0;	/* taille matrice */
	int k = 0;	/* count */
	int data[MAXN][MAXN];
	int Scol[MAXN];
	int Srow[MAXN];
	int Sdiag[2];
	int S = 0;
	int isS = 0;
	
	FILE* f = fopen(FNAME,"r");
	
while(1)
{
	/* lecture */
	fscanf(f,"%d",&N); if( !N ) break;
	k++;
	
	for(i=0;i<N;i++)
	 for(j=0;j<N;j++)
	 {
	 	fscanf(f,"%d",&data[i][j]);
	 }
	
	/* init */
	for(i=0;i<N;i++)
	{
		Scol[i] = 0;
		Srow[i] = 0;
	}
	Sdiag[0] = Sdiag[1] = 0;
	
	/* traitement */
	for(i=0;i<N;i++)
	 for(j=0;j<N;j++)
	 {
	 	elt = data[i][j];
		Scol[j] += elt;
		Srow[i] += elt;
		if( i==j ) Sdiag[0] += elt;
		if( (i+j)==(N-1) ) Sdiag[1] += elt;
	 }
	 
	/* comp */
	S = Scol[0];
	isS = 1;
	
	for(i=0;isS && (i<N); i++) if( Srow[i]!=S ) isS = 0;
	for(i=0;isS && (i<N); i++) if( Scol[i]!=S ) isS = 0;
	for(i=0;isS && (i<2); i++) if( Sdiag[i]!=S ) isS = 0;

	/* affi */
	printf("Square #%i:\n",k);
	printf("This square is %smagic.\n",isS ? "" : "not ");
	printf("\n");
	
} /* while */

	fclose(f);
	return 0;
}
